# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define _with_repolib 1

%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/hibernate-entitymanager/%{version}.%{reltag}-brew
%define repodirlib %{repodir}/lib
%define repodirres %{repodir}/resources
%define repodirsrc %{repodir}/src

%define section free
%define reltag GA_CP05
%define hname hibernate-entitymanager
%define namedversion %{version}.%{reltag}

Summary:        Relational persistence and query service
Name:           hibernate3-entitymanager
Version:        3.4.0
Release:        4.4.%{reltag}%{?dist}
Epoch:          0
License:        LGPL
URL:            http://entitymanager.hibernate.org/
Group:          Database
Source0:        hibernate-entitymanager-%{version}.%{reltag}-src.tar.gz
Source2:		%{hname}-component-info.xml
Source4:		%{hname}-jpp-depmap.xml

Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5
BuildRequires:  maven2
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven-injection-plugin
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven-release
BuildRequires:  maven-surefire
BuildRequires:  maven-test-ext-plugin
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven-doxia-sitetools
BuildRequires:  junit >= 3.8.2
BuildRequires:  hsqldb
BuildRequires:  slf4j >= 0:1.5.6
BuildRequires:  hibernate3-commons-annotations >= 3.1.0
BuildRequires:  dom4j >= 0:1.6.1
BuildRequires:  hibernate3-ejb-persistence-3.0-api >= 0:3.4.0
BuildRequires:  hibernate3 >= 0:3.3.2
BuildRequires:  antlr >= 0:2.7.6
BuildRequires:  objectweb-asm >= 3.1
BuildRequires:  jakarta-commons-collections >= 0:3.1
BuildRequires:  javassist >= 0:3.9.0
BuildRequires:  jboss-transaction-1.0.1-api 
BuildRequires:  log4j >= 1.2.14
BuildRequires:  cglib >= 2.2
BuildRequires:  jboss-parent
BuildRequires:  hibernate3-annotations >= 0:3.4.0

Requires:  java >= 0:1.5
# EAP only - The environment will need to provide a compatible hibernate
Requires:  hibernate3 >= 0:3.3.2
Requires:  hibernate3-commons-annotations >= 0:3.1.0
Requires:  hibernate3-ejb-persistence-3.0-api >= 0:3.4.0
Requires:  hibernate3-annotations >= 0:3.4.0
Requires:  javassist >= 3.9.0
Requires:  jboss-transaction-1.0.1-api
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
EJB3 standardizes the basic APIs and the metadata needed for
any object/relational persistence mechanism. Hibernate
EntityManager implements the programming interfaces,
lifecycle rules and packaging archive support as defined by
the EJB3 persistence specification.
Together with Hibernate Annotations, this wrapper implements
a complete (and standalone) EJB3 persistence provider, as
defined by the JSR-220 public final draft, on top of the
mature Hibernate3 core.

%if %{with_repolib}
%package	 repolib
Summary:	 Artifacts to be uploaded to a repository library
Group:	Development/Libraries/Java

%description	 repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package zip
Summary:        Zip distrubution for %{name}
Group:          Development

%description zip
Zip distribution for %{name}.

%prep
%setup -q -n %{hname}

%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
%{_bindir}/mvn-jpp -e \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE4} \
        -Dmaven.test.failure.ignore=true \
        install javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT
# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}

cp -p target/%{hname}-%{version}.%{reltag}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
cp -p target/%{hname}-%{version}.%{reltag}-sources.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{hname}-sources.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|%{name}|%{hname}|g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

## javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p lgpl.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

# Dist
install -dm 755 $RPM_BUILD_ROOT%{_javadir}/hibernate3-entitymanager-fordev
cp target/hibernate-entitymanager*.zip $RPM_BUILD_ROOT%{_javadir}/hibernate3-entitymanager-fordev/hibernate-entitymanager.zip

#pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
%add_to_maven_depmap org.hibernate %{hname} %{namedversion} JPP %{name}
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom

%if %{with_repolib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
	install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{repodir}/component-info.xml
	sed -i 's/@VERSION@/%{version}.%{reltag}-brew/g' $RPM_BUILD_ROOT%{repodir}/component-info.xml
	tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
	sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
	install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE4} $RPM_BUILD_ROOT%{repodirsrc}
	cp $RPM_BUILD_ROOT%{_javadir}/%{hname}.jar $RPM_BUILD_ROOT%{repodirlib}
	cp $RPM_BUILD_ROOT%{_javadir}/%{hname}-sources.jar $RPM_BUILD_ROOT%{repodirlib} 
	cp $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom $RPM_BUILD_ROOT%{repodirlib}/hibernate-entitymanager.pom
	cp %{_javadir}/hibernate3-ejb-persistence-3.0-api.jar $RPM_BUILD_ROOT%{repodirlib}/ejb3-persistence.jar
	cp %{_javadir}/hibernate3-ejb-persistence-3.0-api-sources.jar $RPM_BUILD_ROOT%{repodirlib}/ejb3-persistence-sources.jar
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/lgpl.txt
%{_javadir}/*.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{repodir}
%endif

%files zip
%defattr(0644,root,root,0755)
%{_javadir}/hibernate3-entitymanager-fordev/*.zip

%changelog
* Fri Jul 12 2012 Strong Liu <stliu@redhat.com> - 0:3.4.0-4.4.GA_CP05
- Upgrade to 3.4.0.GA_CP05

* Sat Feb 12 2011 Strong Liu <stliu@redhat.com> - 0:3.4.0-4.3.GA_CP04
- Upgrade to 3.4.0.GA_CP04

* Sat Feb 12 2011 Strong Liu <stliu@redhat.com> - 0:3.4.0-4.2.GA_CP03
- Rebuild to add Core 3.3.2.GA_CP04 to the c-i.xml

* Sun Jul 25 2010 Strong Liu <stliu@redhat.com> - 0:3.4.0-4.1.GA_CP03
- Upgrade to 3.4.0.GA_CP03
- Remove BR jta_1_1_api
- Add BR jboss-transaction-1.0.1-api
- Add R jboss-tranaction-1.0.1-api

* Thu Jun 03 2010 Strong Liu <stliu@redhat.com> - 0:3.4.0-4.0.GA_CP02
- Correct Release Number

* Wed May 26 2010 Strong Liu <stliu@redhat.com> - 0:3.4.0-1.4.GA_CP02
- Correct component-info.xml

* Sun May 23 2010 Strong Liu <stliu@redhat.com> - 0:3.4.0-1.3.GA_CP02
- Update source tarball to correct version number

* Fri May 21 2010 Strong Liu <stliu@redhat.com> - 0:3.4.0-1.2.GA_CP02
- Update source tarball of 3.4.0.GA_CP02

* Thu May 20 2010 Strong Liu <stliu@redhat.com> - 0:3.4.0-1.1.GA_CP02
- Correct dist directory

* Thu May 20 2010 Strong Liu <stliu@redhat.com> - 0:3.4.0-1.0.GA_CP02
- Upgrade to 3.4.0.GA_CP02
- Add dist package

* Mon Apr 19 2010 Yiqiao Wang <yiwang@redhat.com> - 0:3.4.0-3.1.GA_CP01
- Rebuild

* Fri Jan 29 2010 Strong Liu <stliu@redhat.com> - 0:3.4.0-3.0.GA_CP01
- Add pom to repolib

* Thu Jan 21 2010 Strong Liu <stliu@redhat.com> - 0:3.4.0-2.9.GA_CP01
- Remove java doc zip
- Update patch to remove javadoc section
* Sun Jan 17 2010 Strong Liu <stliu@redhat.com> - 0:3.4.0-2.8.GA_CP01
- Update release tag to rebuild in brew
* Sat Jan 16 2010 Strong Liu <stliu@redhat.com> - 0:3.4.0-2.7.GA_CP01
- Update release tag to include GA_CP01
* Thu Jan 15 2010 Strong Liu <stliu@redhat.com> - 0:3.4.0-2.6
- Nothing change, just increase build tag

* Thu Jan 14 2010 Strong Liu <stliu@redhat.com> - 0:3.4.0-2.5
- Clean up source tarball, remove svn meta files

* Thu Jan 14 2010 Strong Liu <stliu@redhat.com> - 0:3.4.0-2.4
- Upgrade Hibernate Entitymanager to 3.4.0.GA_CP01
- Add compatible line core 3.3.2.GA_CP01
- Add compatible line core 3.3.2.GA_CP01-brew
- Add compatible line annotations 3.4.0.GA_CP01
- Add compatible line annotations 3.4.0.GA_CP01-brew
- Update spec to use maven
- Upload new hibernate-entitymanger 3.4.0.GA_CP01 targall

* Mon Jul 20 2009 Strong Liu <stliu@redhat.com> - 0:3.4.0-2.3
- Update copyrights to 2009

* Sun Jul 19 2009 Gail Badner <gbadner@redhat.com> - 0:3.4.0-2.2
- Add ejb3-persistence-sources.jar
- remove "-<version>" from hibernate-entitymanager source jar file name

* Sun Jul 19 2009 Gail Badner <gbadner@redhat.com> - 0:3.4.0-2.1
- First release for RHEL-4-EP-5
